Attribute VB_Name = "modError"
Option Explicit
Type ERRINFO
  Line As Long
  Desc As String
  FormId As Long
  ObjId As Long
End Type
Public Errors() As ERRINFO
Public MaxError As Long

Sub AddError(ByVal ErrNum As Integer, ByVal Warning As Boolean, Optional Extra As String, Optional Extra2 As String)
  Dim Mes As String

  If Warning Then
    Mes = "Warning"
  Else
    Mes = "Error"
  End If
  With Project
    Mes = Mes + " in object <" + .Forms(CurForm).Nomb + "." + .Forms(CurForm).Objects(CurObj).Nomb + ">, line no. " & (CurLine + 1) & ": "
  End With
  Select Case ErrNum
    Case 0
      Mes = Mes + "Syntax error"
    Case 1
      Mes = Mes + "Unfinished string constant"
    Case 2
      Mes = Mes + "Undeclared data type (" + Extra + ")"
    Case 3
      Mes = Mes + "Invalid statement in this context"
    Case 4
      Mes = Mes + "Identifier already declared elsewhere '" & Extra & "'"
    Case 5
      Mes = Mes + "Object or form '" + Extra + "' does not exist"
    Case 6
      Mes = Mes + "Invalid identifier (" + Extra + ")"
    Case 7
      Mes = Mes + "Invalid logic operator"
    Case 8
      Mes = Mes + "'" & Extra & "' is not a member of structure '" & Extra2 & "'"
    Case 9
      Mes = Mes + "Type mismatch"
    Case 10
      Mes = Mes + "'ENDIF' without 'IF'"
    Case 11
      Mes = Mes + "'ELSE' is not allowed"
    Case 12
      Mes = Mes + "'IF' without 'ENDIF'"
    Case 13
      Mes = Mes + "'LOOP' without 'DO'"
    Case 14
      Mes = Mes + "Double-conditioned loop is not allowed"
    Case 15
      Mes = Mes + "'DO' without 'LOOP'"
    Case 16
      Mes = Mes + "'NEXT' without 'FOR'"
    Case 17
      Mes = Mes + "'FOR' without 'NEXT'"
    Case 18
      Mes = Mes + "'CASE' without 'SELECT'"
    Case 19
      Mes = Mes + "'ENDSELECT' without 'SELECT'"
'    Case 20
'      Mes = Mes + "'ENDSELECT' without 'SELECT'"
    Case 21
      Mes = Mes + "Line label already defined"
    Case 22
      Mes = Mes + "Line label not defined"
    Case 23
      Mes = Mes + "Expected: " & Extra
    Case 24
      Mes = Mes + "Array size must be positive integer number"
    Case 25
      Mes = Mes + "Operator '@' only works on pointers"
    Case 26
      Mes = Mes + "Array in this context requires subscript"
    Case 27
      Mes = Mes + "Control variable must be numeric"
    Case 28
      Mes = Mes + "Internal error. Contact author inmediately"
    Case 29
      Mes = Mes + "ByRef parameter type mismatch"
    Case 30
      Mes = Mes + "Parameter(s) missing"
    Case 31
      Mes = Mes + "Operator '%' valid only in an expression"
    Case 32
      Mes = Mes + "Unsupported property (" & Extra & ")"
    Case 33
      Mes = Mes + "This block has no effect"
    Case 34
      Mes = Mes + "Parameter array cannot have a fixed size"
  End Select
  ReDim Preserve Errors(MaxError)
  With Errors(MaxError)
    .Line = CurLine
    .Desc = Mes
    .ObjId = CurObj
    .FormId = CurForm
  End With
  MaxError = MaxError + 1
  If Not Warning Then Err.Raise 1
End Sub

Sub ClearErrors()
  If MaxError = 0 Then Exit Sub
  InitializeErrors
  frmMain.cmdMessages.BackColor = &H8000000F
End Sub

Sub InitializeErrors()
  Erase Errors
  MaxError = 0
End Sub
