Attribute VB_Name = "modFuncs"
Option Explicit
Type FUNCINFO
  Nomb As String
  Param() As VARINFO
  MaxParam As Long
End Type
Type FRMFUNCINFO
  Funcs() As FUNCINFO
  MaxFunc As Long
End Type
Dim Funcs() As FRMFUNCINFO
Public Const kFunc = 0

Function FuncAdm(ByVal Action As Long, Optional ByVal FormId As Long, Optional ByVal FuncId As Long, Optional Nomb As String, Optional Tipo As String, Optional ByVal Pointer As Boolean, Optional ByVal HiBound As Long) As Long
  Dim i As Long

  Select Case Action
    Case 0 'add
      Funcs(FormId).Funcs(FuncId).Nomb = LCase$(Nomb)
    Case 1 'add param
      With Funcs(FormId).Funcs(FuncId)
        ReDim Preserve .Param(.MaxParam)
        FuncAdm = .MaxParam
        With .Param(.MaxParam)
          .Nomb = LCase$(Nomb)
          .Pointer = Pointer
          .HiBound = HiBound
          .Tipo = Tipo
        End With
        .MaxParam = .MaxParam + 1
      End With
    Case 2 'find
      If Len(Nomb) Then
      With Funcs(FormId)
        For i = 0 To .MaxFunc - 1
          If .Funcs(i).Nomb = LCase$(Nomb) Then
            FuncAdm = i
            Exit Function
          End If
        Next i
      End With
      End If
      FuncAdm = -1
    Case 3 'copy to locals
      With Funcs(FormId).Funcs(FuncId)
        For i = 0 To .MaxParam - 1
          With .Param(i)
            LocVarAdm 0, .Nomb, .Tipo, .Pointer, .HiBound
          End With
        Next i
      End With
    Case 4 'find param
      With Funcs(FormId).Funcs(FuncId)
        For i = 0 To .MaxParam - 1
          If .Param(i).Nomb = LCase$(Nomb) Then
            FuncAdm = i
            Exit Function
          End If
        Next i
      End With
      FuncAdm = -1
  End Select
End Function

Sub CompileFuncs()
  For CurForm = 0 To Project.MaxForm - 1
    CompileForm CurForm
  Next
End Sub

Private Sub CompileForm(ByVal FormId As Long)
  With Project.Forms(FormId)
    For CurObj = 0 To .MaxObj - 1
      frmCompile.Calculate CurObj \ .MaxObj + CurForm, Project.MaxForm
      CompileObj FormId, CurObj
    Next
  End With
End Sub

Private Sub CompileObj(ByVal FormId As Long, ByVal ObjId As Long)
  Dim CodeArray() As String

  With Project.Forms(FormId).Objects(ObjId)
    If .KindOf <> kFunc Then Exit Sub
    FuncAdm 0, FormId, ObjId, .Nomb
    CodeArray = Split(.Code, vbCrLf)
    For CurLine = 0 To UBound(CodeArray)
      CompileLine CodeArray(CurLine)
    Next
  End With
End Sub

Private Sub CompileLine(CodeLine As String)
  Dim Comienzo As Long, i As Long, TmpLng As Long
  Dim TempVars() As VARINFO

  If GetWords(CodeLine, False) Then AddError 1, False
  If Len(Palabra(0)) = 0 Then Exit Sub
  Select Case LCase$(Palabra(0))
    Case "param"
      Comienzo = 1
      For i = 0 To CompListaVar(Comienzo, TempVars, tsGlobVar) - 1
        With TempVars(i)
          If IsTipo(.Tipo) = 2 Or .HiBound <> 0 Then .Pointer = True
          If .HiBound > 0 Then AddError 34, False
          FuncAdm 1, CurForm, CurObj, .Nomb, .Tipo, .Pointer, .HiBound
        End With
      Next i
    Case Else
      Exit Sub
  End Select
  If Len(Palabra(Comienzo)) Then AddError 23, False, "End of Statement"
End Sub

Private Sub ParamConcat(Comienzo As Long, Func As FUNCINFO)
  Dim i As Long, HiBound As Long
  Dim TmpStr As String

  With Func
    For i = 0 To .MaxParam - 1
      With .Param(i)
        ToFileInt GetDataTypeId(.Tipo, .Pointer)
        If .HiBound = -1 Then
          TmpStr = AnalizarTipo(Comienzo, True, HiBound)
          If HiBound = 0 Then AddError 23, False, "Array"
          If TmpStr <> .Tipo Then AddError 29, False
        ElseIf .Pointer Then
          TmpStr = AnalizarTipo(Comienzo, True, HiBound)
          If HiBound Then AddError 9, False
          If TmpStr <> .Tipo Then AddError 29, False
        Else
          Expression Comienzo
        End If
      End With
      If i <> .MaxParam - 1 Then
        If Palabra(Comienzo) <> "," Then AddError 23, False, "','"
        Comienzo = Comienzo + 1
      End If
    Next i
  End With
End Sub

Private Sub ParamComp(Comienzo As Long, Func As FUNCINFO)
  ToFileInt Func.MaxParam
  If Palabra(Comienzo) = "(" Then
    Comienzo = Comienzo + 1
    If Palabra(Comienzo) = ")" Then
      If Func.MaxParam Then AddError 30, False
    Else
      ParamConcat Comienzo, Func
      If Palabra(Comienzo) <> ")" Then AddError 23, False, "')'"
    End If
    Comienzo = Comienzo + 1
  Else
    If Func.MaxParam Then AddError 30, False
  End If
End Sub

Function FuncAnalyze(Comienzo As Long) As Boolean
  Dim Ret As Long, FormId As Long

  FormId = IsForm(Palabra(Comienzo))
  If FormId <> -1 Then
    If Palabra(Comienzo + 1) <> "." Then Exit Function
    Ret = IsObj(FormId, Palabra(Comienzo + 2), CurForm)
    If Ret = -1 Then Exit Function
    Ret = FuncAdm(2, FormId, , Palabra(Comienzo + 2))
    If Ret = -1 Then Exit Function
    Comienzo = Comienzo + 2
  Else
    Ret = FuncAdm(2, CurForm, , Palabra(Comienzo))
    If Ret = -1 Then Exit Function
    FormId = CurForm
  End If
  ToFileInt 12720
  ToFileInt FormId
  ToFileInt Ret
  Comienzo = Comienzo + 1
  ParamComp Comienzo, Funcs(FormId).Funcs(Ret)
  FuncAnalyze = True
End Function

Sub InitializeFuncs()
  Dim Max As Long, i As Long

  With Project
    ReDim Funcs(.MaxForm - 1)
    For i = 0 To .MaxForm - 1
      Max = .Forms(i).MaxObj
      If Max Then
        With Funcs(i)
          ReDim .Funcs(Max - 1)
          .MaxFunc = Max
        End With
      End If
    Next i
  End With
End Sub
