Attribute VB_Name = "modVariables"
Option Explicit
Type VARINFO
  Nomb As String
  Tipo As String
  Pointer As Boolean
  HiBound As Long
  BytePos As Long
End Type
Dim GlobVars() As VARINFO
Dim MaxGlobVar As Long
Dim LocVars() As VARINFO
Dim MaxLocVar As Long

Function GlobVarAdm(ByVal Action As Long, Nomb As String, Optional Tipo As String, Optional Pointer As Boolean, Optional HiBound As Long) As Long
  Dim i As Long

  Select Case Action
    Case 0 'add var
      ReDim Preserve GlobVars(MaxGlobVar)
      With GlobVars(MaxGlobVar)
        .Nomb = Nomb
        .Pointer = Pointer
        .HiBound = HiBound
        .Tipo = Tipo
        If MaxGlobVar Then
          With GlobVars(MaxGlobVar - 1)
            i = .BytePos + GetSize(.Tipo, .Pointer, .HiBound)
          End With
          .BytePos = i
        End If
      End With
      GlobVarAdm = MaxGlobVar
      MaxGlobVar = MaxGlobVar + 1
    Case 1 'find var
      For i = 0 To MaxGlobVar - 1
        With GlobVars(i)
          If .Nomb = LCase$(Nomb) Then
            Pointer = .Pointer
            Tipo = .Tipo
            HiBound = .HiBound
            GlobVarAdm = i
            Exit Function
          End If
        End With
      Next i
      GlobVarAdm = -1
    Case 3 'get var pos
      i = GlobVarAdm(1, Nomb)
      If i <> -1 Then
        GlobVarAdm = GlobVars(i).BytePos
      Else
        GlobVarAdm = -1
      End If
    Case 4 'get necesary space
      If MaxGlobVar = 0 Then Exit Function
      With GlobVars(MaxGlobVar - 1)
        GlobVarAdm = .BytePos + GetSize(.Tipo, .Pointer, .HiBound)
      End With
  End Select
End Function

Function LocVarAdm(ByVal Action As Long, Nomb As String, Optional Tipo As String, Optional Pointer As Boolean, Optional HiBound As Long) As Long
  Dim i As Long

  Select Case Action
    Case 0 'add var
      ReDim Preserve LocVars(MaxLocVar)
      With LocVars(MaxLocVar)
        .Nomb = Nomb
        .Pointer = Pointer
        .HiBound = HiBound
        .Tipo = Tipo
        If MaxLocVar Then
          With LocVars(MaxLocVar - 1)
            i = .BytePos + GetSize(.Tipo, .Pointer, .HiBound)
          End With
          .BytePos = i
        End If
      End With
      LocVarAdm = MaxLocVar
      MaxLocVar = MaxLocVar + 1
    Case 1 'find var
      For i = 0 To MaxLocVar - 1
        With LocVars(i)
          If .Nomb = LCase$(Nomb) Then
            Pointer = .Pointer
            Tipo = .Tipo
            HiBound = .HiBound
            LocVarAdm = i
            Exit Function
          End If
        End With
      Next i
      LocVarAdm = -1
    Case 2 'clear loc vars
      Erase LocVars
      MaxLocVar = 0
    Case 3 'get var pos
      i = LocVarAdm(1, Nomb)
      If i <> -1 Then
        LocVarAdm = LocVars(i).BytePos
      Else
        LocVarAdm = -1
      End If
    Case 4 'get necesary space
      If MaxLocVar = 0 Then Exit Function
      With LocVars(MaxLocVar - 1)
        LocVarAdm = .BytePos + GetSize(.Tipo, .Pointer, .HiBound)
      End With
    Case 5 'add var and get pos
      LocVarAdm = LocVars(LocVarAdm(0, Nomb, Tipo, Pointer, HiBound)).BytePos
  End Select
End Function

Function CompListaVar(Comienzo As Long, VarBuff() As VARINFO, ByVal Scope As TIPOSCOPE, Optional ByVal Extra As Long) As Long
  Dim i As Long, MaxBound As Long

  Erase VarBuff
  MaxBound = 0
  Do
    ReDim Preserve VarBuff(MaxBound)
    With VarBuff(MaxBound)
      If Palabra(Comienzo) = "@" Then
        .Pointer = True
        Comienzo = Comienzo + 1
      End If
      .Nomb = LCase$(Palabra(Comienzo))
      If Len(.Nomb) = 0 Then AddError 23, False, "Identifier"
      If Not IsValid(.Nomb) Then AddError 6, False, Palabra(Comienzo)
      If IsIdent(Scope, .Nomb, Extra) Then AddError 4, False, Palabra(Comienzo)
      For i = 0 To MaxBound - 1
        If VarBuff(i).Nomb = .Nomb Then AddError 4, False, Palabra(Comienzo)
      Next i
      Comienzo = Comienzo + 1
      If Palabra(Comienzo) = "[" Then
        If Palabra(Comienzo + 1) = "]" Then
          .HiBound = -1
          Comienzo = Comienzo + 2
        Else
          .HiBound = Val(Palabra(Comienzo + 1))
          If .HiBound < 1 Then AddError 24, False
          If Palabra(Comienzo + 2) <> "]" Then AddError 23, False, "'['"
          Comienzo = Comienzo + 3
        End If
      End If
      If Palabra(Comienzo) <> ":" Then AddError 23, False, "':'"
      Comienzo = Comienzo + 1
      .Tipo = LCase$(Palabra(Comienzo))
      i = IsTipo(.Tipo)
      If i = 0 Then AddError 2, False, Palabra(Comienzo)
      If Scope = tsParam And (i = 2 Or .HiBound <> 0) Then .Pointer = True
      Comienzo = Comienzo + 1
      If Palabra(Comienzo) <> "," Then Exit Do
      Comienzo = Comienzo + 1
    End With
    MaxBound = MaxBound + 1
  Loop
  CompListaVar = MaxBound + 1
End Function

Function AnalizarTipo(Comienzo As Long, ByVal InExpr As Boolean, Optional HiBound As Long) As String
  Dim Ret As Long, Ptr As Boolean

  Ret = LocVarAdm(1, Palabra(Comienzo))
  If Ret <> -1 Then
    With LocVars(Ret)
      ToFileLng .BytePos
      ToFileInt 17310
      Ptr = .Pointer
      HiBound = .HiBound
      ToFileInt GetDataTypeId(.Tipo, Ptr)
      AnalizarTipo = .Tipo
    End With
  Else
    Ret = GlobVarAdm(1, Palabra(Comienzo))
    If Ret = -1 Then Exit Function
    With GlobVars(Ret)
      ToFileLng .BytePos
      ToFileInt 17320
      Ptr = .Pointer
      HiBound = .HiBound
      ToFileInt GetDataTypeId(.Tipo, Ptr)
      AnalizarTipo = .Tipo
    End With
  End If
  Comienzo = Comienzo + 1
  Select Case Palabra(Comienzo)
    Case "@"
      If Not Ptr Then AddError 25, False
      Comienzo = Comienzo + 1
      ToFileInt 17600
      AnalizarTipo = pNumeric
      Exit Function
    Case "%"
      If Not InExpr Then AddError 31, False
      Comienzo = Comienzo + 1
      ToFileInt 17550
      ToFileInt -1
      ToFileInt 17600
      AnalizarTipo = pNumeric
      Exit Function
    Case Else
      If Ptr Then
        ToFileInt 17510
        ToFileInt GetDataTypeId(AnalizarTipo, False) 'GetSize(AnalizarTipo, , , False)
      End If
  End Select
  If HiBound Then
    If Palabra(Comienzo) = "[" Then
      If HiBound = -1 Then ToFileInt 17540
      ToFileInt 17520
      Comienzo = Comienzo + 1
      Expression Comienzo
      If Palabra(Comienzo) <> "]" Then AddError 23, False, "']'"
      ToFileInt GetSize(AnalizarTipo)
      HiBound = 0
      Comienzo = Comienzo + 1
    End If
  End If
  If IsTipo(AnalizarTipo) = 2 Then AnalizarTipo = AnalizarStruct(Comienzo, AnalizarTipo, InExpr)
  ToFileInt 17600
End Function

Function IsVarRef(Nomb As String) As Boolean
  IsVarRef = LocVarAdm(1, Nomb) <> -1
  If IsVarRef Then Exit Function
  IsVarRef = GlobVarAdm(1, Nomb) <> -1
  'If IsVarRef Then Exit Function
End Function

Sub InitializeVariable()
  Erase GlobVars
  MaxGlobVar = 0
  Erase LocVars
  MaxLocVar = 0
End Sub
